{*************************************}
{* Main unit for SQLite2 application *}
{*************************************}

unit sqlite2_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, mysql57conn, sqldb, odbcconn, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  {***********}
  { TfSQLite2 }
  {***********}
  TfSQLite2 = class(TForm)
    StaticText1: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edCities: TEdit;
    edMess: TEdit;
    btConnect: TButton;
    btQuery: TButton;
    btExit: TButton;
    dbODBCConnection: TODBCConnection;
    dbSQLTransaction: TSQLTransaction;
    dbSQLQuery: TSQLQuery;
    procedure btConnectClick(Sender: TObject);
    procedure btQueryClick(Sender: TObject);
    procedure btExitClick(Sender: TObject);
  end;

var
  fSQLite2: TfSQLite2;

implementation

{$R *.lfm}

{***********}
{ TfSQLite2 }
{***********}

{ Button "Connect": Connect to "world" databse }

procedure TfSQLite2.btConnectClick(Sender: TObject);

begin
  if dbODBCConnection.Connected then                                           // close (open) database connection
    dbODBCConnection.Close;
  // Set the connection parameters.
  dbODBCConnection.DatabaseName := 'SQLite3 Datasource';
  dbODBCConnection.UserName := '';
  dbODBCConnection.Password := '';
  dbODBCConnection.Params.Add('DATABASE=C:\Programs\SQLite\world.db');
  dbODBCConnection.Params.Add('NOCREAT=true');
  // Connect to the world database
  try
    dbODBCConnection.Open;
    edMess.Text := 'Connection to SQLite database "world" = OK!';
  except
    on E: ESQLDatabaseError do
      edMess.Text := E.Message;
  end;
end;

{ Button "Query": Display number of cities in "city" table }

procedure TfSQLite2.btQueryClick(Sender: TObject);

var
  Count: Integer;

begin
  if dbODBCConnection.Connected then begin
    // Query the database
    dbSQLQuery.SQL.Text := 'SELECT count(*) FROM city';
    try
      dbSQLQuery.Open;
      if dbSQLQuery.EOF then
        Count := 0
      else
        Count := dbSQLQuery.Fields[0].AsInteger;
      dbSQLQuery.Close;
      // Display the query result
      edCities.Text := IntToStr(Count);
    except
      on E: ESQLDatabaseError do
        edMess.Text := E.Message;
    end;
  end;
end;

{ Button "Exit": Disconnect from databse and exit application }

procedure TfSQLite2.btExitClick(Sender: TObject);

begin
  if dbODBCConnection.Connected then                                           // close (open) database connection
    dbODBCConnection.Close;
  Close;
end;

end.

